// EinsDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "afxtempl.h"
#include "Eins.h"
#include "EinsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEinsDlg Dialogfeld

CEinsDlg::CEinsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEinsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEinsDlg)
	m_Reihenfolge = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEinsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEinsDlg)
	DDX_Text(pDX, IDC_EDIT, m_Reihenfolge);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEinsDlg, CDialog)
	//{{AFX_MSG_MAP(CEinsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEinsDlg Nachrichten-Handler

BOOL CEinsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}


// Statistische Auswertung

void CEinsDlg::OnOK() 
{
	// drei Listen definieren
	CList<int,int> Links,Rechts,Ausgang;
	// Siege festhalten
	CByteArray arSiege;
	// Anzahl Muse feststellen
	int nAnzahl = 0;
	// nicht realisierbare Folgen erkennen
	bool bUnmoeglich = false;

	// Austrittsreihenfolge lesen
	UpdateData();
	CString strMaeuse = m_Reihenfolge;

	// alle Listen lschen
	Links.RemoveAll();
	Rechts.RemoveAll();
	Ausgang.RemoveAll();

	// Austrittreihenfolge bearbeiten
	while (strMaeuse.GetLength()>0)
	{
		// Kommata entfernen
		if (strMaeuse[0]==',')
			strMaeuse = strMaeuse.Right(strMaeuse.GetLength()-1);

		// Zahl lesen (noch als Zeichenkette)
		CString strZahl = strMaeuse.SpanIncluding("0123456789");
		// aus der Austrittsreihenfolge entfernen
		strMaeuse = strMaeuse.Right(strMaeuse.GetLength()-strZahl.GetLength());

		// Zeichenkette in Zahl umwandeln
		int nZahl = atoi(strZahl);
		// im Ausgang vermerken
		Ausgang.AddTail(nZahl);

		// Gesamtanzahl der Muse eventuell erhhen
		if (nZahl>nAnzahl)
			nAnzahl = nZahl;
	}

	// alle Muse im Eingang versammeln, Nr.1 an der Spitze
	for (int nLauf = nAnzahl; nLauf>0; nLauf--)
		Links.AddHead(nLauf);

	// Feld fr Siege ausreichend gro dimensionieren
	arSiege.SetSize(nAnzahl+1);

	// solange, bis alle im Ausgang oder nicht realisierbar
	while ((!bUnmoeglich)&&!(Links.IsEmpty()&&Rechts.IsEmpty()))
	{
		// Eingang leer ?
		if (Links.IsEmpty())
		{
			// vom Stauraum zum Ausgang schicken, Reihenfolge beachten
			while ((!Rechts.IsEmpty())&&(!Ausgang.IsEmpty())&&
				    (Rechts.GetHead()==Ausgang.GetHead()))
			{
				// realisierbare Folge, also Muse entfernen
				Rechts.RemoveHead();
				Ausgang.RemoveHead();
			}
			// Stauraum nicht leer ?
			if (!Rechts.IsEmpty())
				// doch nicht realisierbare Folge
				bUnmoeglich = true;
		}
		else
		// Eingang nicht leer
		{
			// Stauraum leer ?
			if (Rechts.IsEmpty())
			{
				// Maus vom Eingang zum Stauraum schicken
				Rechts.AddHead(Links.GetHead());
				Links.RemoveHead();
			}
			else
				// Stauraum belegt

				// steht Maus im Stauraum als nchste in der Austrittsfolge ?
				if (Rechts.GetHead()==Ausgang.GetHead())
				{
					// Maus im Stauraum gewinnt, Sieg vermerken
					arSiege[Rechts.GetHead()]++;
					// aus Listen entfernen
					Rechts.RemoveHead();
					Ausgang.RemoveHead();
				}
				else
				{
					// Maus im Eingang gewinnt
					arSiege[Links.GetHead()]++;
					// in den Stauraum schicken
					Rechts.AddHead(Links.GetHead());
					Links.RemoveHead();
				}
		}
	}

	// unmgliche Folge ?
	if (bUnmoeglich)
		// Fehlermeldung
		AfxMessageBox("Eingegebene Austrittsreihenfolge ist nicht mglich.");
	else
	{
		CString strAusgabe;
		// alle Muse auf ihre Siege hin untersuchen
		for (nLauf=1; nLauf<nAnzahl; nLauf++)
		{
			CString strAdd;
			// in Zeichenkette umwandeln
			strAdd.Format("Maus %i gewann %imal.\n", nLauf, arSiege[nLauf]);
			// fr Ausgabe aufbereiten
			strAusgabe += strAdd;
		}
		// Siege pro Maus ausgeben
		AfxMessageBox(strAusgabe);
	}
}
